/*
 *                 Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 *
 *
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Tom Wheeler. Portions Copyright 2006 Tom Wheeler. All Rights 
 * Reserved. Any future updates to this code will be made available at 
 * http://www.tomwheeler.com/netbeans/
 */

package com.tomwheeler.example.tdlfile.impl;

import com.tomwheeler.example.tdlfile.intf.TodoListItem;
import java.awt.Image;
import java.beans.*;

/**
 * <p>
 * This class describes the properties of the BasicTodoListItem class, which 
 * follows JavaBean conventions.
 * </p>
 *
 * @author <a href="http://www.tomwheeler.com/netbeans/">Tom Wheeler</a>
 */
public class BasicTodoListItemBeanInfo extends SimpleBeanInfo {

    public PropertyDescriptor[] getPropertyDescriptors() {
        try {
            // boilerplate code: associates information with specific properties
            
            PropertyDescriptor namePd = new PropertyDescriptor(TodoListItem.PROP_NAME, BasicTodoListItem.class);
            namePd.setBound(true);
            namePd.setDisplayName("Name");

            PropertyDescriptor descPd = new PropertyDescriptor(TodoListItem.PROP_DESC, BasicTodoListItem.class);
            descPd.setBound(true);
            descPd.setDisplayName("Description");

            PropertyDescriptor dueDatePd = new PropertyDescriptor(TodoListItem.PROP_DUE_DATE, BasicTodoListItem.class);
            dueDatePd.setBound(true);
            dueDatePd.setDisplayName("Due Date");

            return new PropertyDescriptor[]{ namePd, descPd, dueDatePd };

        } catch (IntrospectionException e) {
            throw new Error(e.toString());
        }
    }

    public Image getIcon(int type) {
        if ((type == BeanInfo.ICON_COLOR_16x16) || (type == BeanInfo.ICON_MONO_16x16)) {
            return loadImage("com/tomwheeler/example/tdlfile/tdlitem.png");
        }

        return null;
    }    
}
